// OcvitaBarcodePropPage.cpp : Implementation of the COcvitaBarcodePropPage property page class.

#include "stdafx.h"
#include "OcvitaBarcode.h"
#include "OcvitaBarcodePropPage.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define OB_MAX_SYMBOLOGY 142

IMPLEMENT_DYNCREATE(COcvitaBarcodePropPage, COlePropertyPage)



// Message map

BEGIN_MESSAGE_MAP(COcvitaBarcodePropPage, COlePropertyPage)
//	ON_EN_CHANGE(IDC_SYMBOLOGY, &COcvitaBarcodePropPage::OnEnChangeSymbology)
	ON_CBN_SELCHANGE(IDC_SYMNAME, &COcvitaBarcodePropPage::OnCbnSelchangeSymname)
	ON_EN_KILLFOCUS(IDC_SYMBOLOGY, &COcvitaBarcodePropPage::OnEnKillfocusSymbology)
END_MESSAGE_MAP()



// Initialize class factory and guid

IMPLEMENT_OLECREATE_EX(COcvitaBarcodePropPage, "Ocvita.BarcodePropPage",
	0xbea1c170, 0xb582, 0x4786, 0xba, 0xda, 0x10, 0x5d, 0x87, 0xaa, 0x86, 0x82)



// COcvitaBarcodePropPage::COcvitaBarcodePropPageFactory::UpdateRegistry -
// Adds or removes system registry entries for COcvitaBarcodePropPage

BOOL COcvitaBarcodePropPage::COcvitaBarcodePropPageFactory::UpdateRegistry(BOOL bRegister)
{
	if (bRegister)
		return AfxOleRegisterPropertyPageClass(AfxGetInstanceHandle(),
			m_clsid, IDS_OCVITABARCODE_PPG);
	else
		return AfxOleUnregisterClass(m_clsid, NULL);
}



// COcvitaBarcodePropPage::COcvitaBarcodePropPage - Constructor

COcvitaBarcodePropPage::COcvitaBarcodePropPage() :
	COlePropertyPage(IDD, IDS_OCVITABARCODE_PPG_CAPTION)
		, m_symbology(0)
		, m_barcode(_T(""))
		, m_whitespace_width(0)
		, m_height(0)
		, m_border_width(0)
		, m_output_options(0)
		, m_fgcolour(_T(""))
		, m_bgcolour(_T(""))
		, m_symname(_T(""))
{
}



// COcvitaBarcodePropPage::DoDataExchange - Moves data between page and properties

void COcvitaBarcodePropPage::DoDataExchange(CDataExchange* pDX)
{
	DDP_Text(pDX, IDC_SYMBOLOGY, m_symbology, _T("symbology"));
	DDX_Text(pDX, IDC_SYMBOLOGY, m_symbology);
	DDV_MinMaxLong(pDX, m_symbology, 1, OB_MAX_SYMBOLOGY);

	DDP_Text(pDX, IDC_BARCODE, m_barcode, _T("barcode"));
	DDX_Text(pDX, IDC_BARCODE, m_barcode);

	DDP_Text(pDX, IDC_WHITESPACE_WIDTH, m_whitespace_width, _T("whitespace_width"));
	DDX_Text(pDX, IDC_WHITESPACE_WIDTH, m_whitespace_width);
	DDV_MinMaxLong(pDX, m_whitespace_width, 0, 100);

	DDP_Text(pDX, IDC_HEIGHT, m_height, _T("height"));
	DDX_Text(pDX, IDC_HEIGHT, m_height);
	DDV_MinMaxLong(pDX, m_height, 0, 1000);

	DDP_Text(pDX, IDC_BORDER_WIDTH, m_border_width, _T("border_width"));
	DDX_Text(pDX, IDC_BORDER_WIDTH, m_border_width);
	DDV_MinMaxLong(pDX, m_border_width, 0, 1000);

	DDP_Text(pDX, IDC_OUTPUT_OPTIONS, m_output_options, _T("output_options"));
	DDX_Text(pDX, IDC_OUTPUT_OPTIONS, m_output_options);

	DDP_Text(pDX, IDC_FGCOLOUR, m_fgcolour, _T("fgcolour"));
	DDX_Text(pDX, IDC_FGCOLOUR, m_fgcolour);
	DDV_MaxChars(pDX, m_fgcolour, 6);

	DDP_Text(pDX, IDC_BGCOLOUR, m_bgcolour, _T("bgcolour"));
	DDX_Text(pDX, IDC_BGCOLOUR, m_bgcolour);
	DDV_MaxChars(pDX, m_bgcolour, 6);

	DDP_PostProcessing(pDX);
	DDX_CBString(pDX, IDC_SYMNAME, m_symname);
	DDX_Control(pDX, IDC_SYMNAME, c_symname);
}



// COcvitaBarcodePropPage message handlers
BOOL COcvitaBarcodePropPage::OnInitDialog()
{
	CDialog::OnInitDialog();

	// symnames table
	symnames[1]  = "Code 11";
	symnames[2]  = "Code 2 of 5";
	symnames[3]  = "Interleaved 2 of 5";
	symnames[4]  = "Code 2 of 5 IATA";
	symnames[6]  = "Code 2 of 5 Data Logic";
	symnames[7]  = "Code 2 of 5 Industrial";
	symnames[8]  = "Code 3 of 9 (Code 39)";
	symnames[9]  = "Extended Code 3 of 9 (Code 39+)";
	symnames[13] = "EAN (EAN-8/13 auto select)";
	symnames[16] = "GS1-128";
	symnames[18] = "Codabar";
	symnames[20] = "Code 128 (subset auto select)";
	symnames[21] = "Deutshe Post Leitcode";
	symnames[22] = "Deutshe Post Identcode";
	symnames[23] = "Code 16K";
	symnames[24] = "Code 49";
	symnames[25] = "Code 93";
	symnames[28] = "Flattermarken";
	symnames[29] = "GS1 DataBar-14";
	symnames[30] = "GS1 DataBar Limited";
	symnames[31] = "GS1 DataBar Expanded";
	symnames[32] = "Telepen Alpha";
	symnames[34] = "UPC A";
	symnames[37] = "UPS E";
	symnames[40] = "PostNet";
	symnames[47] = "MSI Plessey";
	symnames[49] = "FIM";
	symnames[50] = "LOGMARS";
	symnames[51] = "Pharmacode One-Track";
	symnames[52] = "PZN";
	symnames[53] = "Pharmacode Two-Track";
	symnames[55] = "PDF417";
	symnames[56] = "PDF417 Truncated";
	symnames[57] = "Maxicode";
	symnames[58] = "QR Code";
	symnames[60] = "Code 128 (Subset B)";
	symnames[63] = "Australia Post Standard Customer";
	symnames[66] = "Australia Post Reply Paid";
	symnames[67] = "Australia Post Routing";
	symnames[68] = "Australia Post Redirection";
	symnames[69] = "ISBN (EAN-13 with verification stage)";
	symnames[70] = "Royal Mail 4 State (RM4SCC)";
	symnames[71] = "Data Matrix";
	symnames[72] = "EAN-14";
	symnames[75] = "NVE-18";
	symnames[76] = "Japanese Post";
	symnames[77] = "Korea Post";
	symnames[79] = "GS1 DataBar-14 Stacked";
	symnames[80] = "GS1 DataBar-14 Stacked Omnidirectional";
	symnames[81] = "GS1 DataBar Expanded Stacked";
	symnames[82] = "PLANET";
	symnames[84] = "MicroPDF417";
	symnames[85] = "USPS OneCode";
	symnames[86] = "Plessey Code";
	symnames[87] = "Telepen Numeric";
	symnames[89] = "ITF-14";
	symnames[90] = "Dutch Post KIX Code";
	symnames[92] = "Aztec Code";
	symnames[93] = "DAFT Code";
	symnames[97] = "Micro QR Code";
	symnames[98] = "HIBC Code 128";
	symnames[99] = "HIBC Code 39";
	symnames[102] = "HIBC Data Matrix";
	symnames[104] = "HIBC QR Code";
	symnames[106] = "HIBC PDF417";
	symnames[108] = "HIBC MicroPDF417";
	symnames[112] = "HIBC Aztec Code";
	symnames[128] = "Aztec Runes";
	symnames[129] = "Code 32";
	symnames[130] = "Composite Symbol with EAN linear component";
	symnames[131] = "Composite Symbol with GS1-128 linear component";
	symnames[132] = "Composite Symbol with GS1 DataBar-14 linear component";
	symnames[133] = "Composite Symbol with GS1 DataBar Limited component";
	symnames[134] = "Composite Symbol with GS1 DataBar Extended component";
	symnames[135] = "Composite Symbol with UPC A linear component";
	symnames[136] = "Composite Symbol with UPC E linear component";
	symnames[137] = "Composite Symbol with GS1 DataBar-14 Stacked component";
	symnames[138] = "Composite Symbol with GS1 DataBar-14 Stacked Omnidirectional component";
	symnames[139] = "Composite Symbol with GS1 DataBar Expanded Stacked component";
	symnames[140] = "Channel Code";
	symnames[141] = "Code One";
	symnames[142] = "Grid Matrix";

	POSITION pos = symnames.GetStartPosition();
	long nKey;
	CString sValue;
	while (pos != NULL)
	{
		symnames.GetNextAssoc(pos, nKey, sValue);
		c_symname.AddString(sValue);
		if (nKey == m_symbology)
			c_symname.SelectString(-1, sValue);
	}
	return TRUE;
}

//void COcvitaBarcodePropPage::OnEnChangeSymbology()
//{
//	// TODO:  If this is a RICHEDIT control, the control will not
//	// send this notification unless you override the COlePropertyPage::OnInitDialog()
//	// function and call CRichEditCtrl().SetEventMask()
//	// with the ENM_CHANGE flag ORed into the mask.
//	//MessageBox(_T("OnEnChangeSymbology"));
//
//	// TODO:  Add your control notification handler code here
//}

void COcvitaBarcodePropPage::OnCbnSelchangeSymname()
{
	//MessageBox(_T("OnCbnSelchangeSymname"));

	// TODO: Add your control notification handler code here
	POSITION pos = symnames.GetStartPosition();
	long nKey;
	CString sValue, sSelected;
	c_symname.GetLBText(c_symname.GetCurSel(), sSelected);
	while (pos != NULL)
	{
		symnames.GetNextAssoc(pos, nKey, sValue);
		if (sValue == sSelected)
		{
			SetDlgItemInt(IDC_SYMBOLOGY, nKey);
			break;
		}
	}

}

void COcvitaBarcodePropPage::OnEnKillfocusSymbology()
{
	// TODO: Add your control notification handler code here
	CString sValue;

	//UpdateData(true);
	int t_symbology;
	t_symbology = GetDlgItemInt(IDC_SYMBOLOGY);

	if (t_symbology < 1)
		t_symbology = 1;
	
	if (t_symbology > OB_MAX_SYMBOLOGY)
		t_symbology = OB_MAX_SYMBOLOGY;

	for (int i = t_symbology; !symnames.Lookup(i, sValue); i--);

	SetDlgItemInt(IDC_SYMBOLOGY, t_symbology);

	c_symname.SelectString(-1, sValue);
}
